import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class ColorPanel extends JPanel implements MouseListener
{
  private final int size = 40;

  private JFrame owner;
  private ColorSelector colorSelector;
  private int index;

  public ColorPanel(JFrame owner, ColorSelector colorSelector, Color color, int index)
  {
    this.owner = owner;
    this.colorSelector = colorSelector;
    this.index = index;
    setBackground(color);
    addMouseListener(this);
    setPreferredSize(new Dimension(size, size));
  }

  public void mousePressed(MouseEvent e)
  {
    if (e.isShiftDown())
    {
      JColorChooser colorChooser = new JColorChooser();
      Color color = colorChooser.showDialog(owner, "Color Selector", getBackground());
      if (color != null)
      {
        setBackground(color);
        colorSelector.setColor(color, index);
      }
    }
    else
      colorSelector.setCurrentState(index);
  }

  public void mouseEntered(MouseEvent e)
  {
    colorSelector.setIdentifier(index);
  }

  public void mouseExited(MouseEvent e)
  {
    colorSelector.hideIdentifier();
  }

  public void mouseClicked(MouseEvent e) {}
  public void mouseReleased(MouseEvent e) {}
}
