import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

class GridSpinner extends JLabel implements MouseListener
{
  private String label;
  private int value;
  private int minimum;
  private int maximum;
  private boolean isLabel;
  private boolean adjust;

  public GridSpinner(int height, int width, String label, int value, int minimum, int maximum, boolean isLabel)
  {
    this.label = label;
    this.value = value;
    this.minimum = minimum;
    this.maximum = maximum;
    this.isLabel = isLabel;
    this.adjust = adjust;
    addMouseListener(this);
    setPreferredSize(new Dimension(height, width));
    setFont(new Font("Monospaced", Font.PLAIN, 14));
    setHorizontalAlignment(CENTER);
    if (isLabel)
      setText(label);
    else
    {
      adjustText(value);
      setBorder(BorderFactory.createEtchedBorder());
    }
  }

  public int getValue()
  {
    return value;
  }

  public void setValue(int i)
  {
    value = i;
    adjustText(i);
  }
  
  private void adjustText(int value)
  {
    String l = label;
    if (l != "")
    {
      l += " ";
      if (value >= 0)
        l += " ";
      if (Math.abs(value) < 10)
        l += " ";
    }
    setText(l + value);
  }

  public void mousePressed(MouseEvent e)
  {
    if (isLabel)
      return;
    if (e.isShiftDown())
    {
      if (value == minimum)
      {
        adjustText(maximum);
        value = maximum;
      }
      else
        adjustText(--value);
    }
    else
    {
      if (value == maximum)
      {
        adjustText(minimum);
        value = minimum;
      }
      else
        adjustText(++value);
    }
  }

  public void mouseExited(MouseEvent e) {}
  public void mouseClicked(MouseEvent e) {}
  public void mouseEntered(MouseEvent e) {}
  public void mouseReleased(MouseEvent e) {}
}
