import java.io.*;

class Patterns
{
  private File patternDirectory;
  private String[] patternFileNames;
  private int numberPatterns;
  private int currentPattern;

  public Patterns(File patternDirectory, String patternName)
  {
    this.patternDirectory = patternDirectory;
    String s[] = patternDirectory.list();
    numberPatterns = 0;
    for (int i = 0; i < s.length; i++)
      if (s[i].endsWith(".sqc"))
        numberPatterns++;
    if (numberPatterns > 0)
    {
      patternFileNames = new String[numberPatterns];
      int j = 0;
      for (int i = 0; i < s.length; i++)
        if (s[i].endsWith(".sqc"))
          patternFileNames[j++] = s[i];
      currentPattern = 0;
      for (int i = 0; i < patternFileNames.length; i++)
        if (patternFileNames[i].equals(patternName))
          currentPattern = i;
    }
  }

  public File getNext()
  {
    if (++currentPattern == patternFileNames.length)
      currentPattern = 0;
    return new File(patternDirectory + File.separator + patternFileNames[currentPattern]);
  }

  public File getPrevious()
  {
    if (--currentPattern < 0)
      currentPattern = patternFileNames.length - 1;
    return new File(patternDirectory + File.separator + patternFileNames[currentPattern]);
  }

  public File getCurrent()
  {
    return new File(patternDirectory + File.separator + patternFileNames[currentPattern]);
  }

  public int getNumberPatterns()
  {
    return numberPatterns;
  }

  public File getDirectory()
  {
    return patternDirectory;
  }
}
