import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class PrimordiaDialog extends JDialog implements ActionListener
{
  private GridSpinner K;
  private GridSpinner L;
  private GridSpinner M;
  private GridSpinner N;
  private JButton okButton;
  private JButton cancelButton;
  private boolean changed = false;

  public PrimordiaDialog(JFrame owner, Primordia rule)
  {
    super(owner, "", true);
    setTitle("Primordia");
    JPanel basePanel = new JPanel();
    basePanel.setBorder(BorderFactory.createLineBorder(basePanel.getBackground(), 15));
    basePanel.setLayout(new BorderLayout());
    JPanel parametersPanel = new JPanel();
    JPanel gridPanel = new JPanel();
    gridPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
    gridPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "Parameters"));
    K = new GridSpinner(70, 20, "K", rule.getK(), 0, 30, false);
    L = new GridSpinner(70, 20, "L", rule.getL(), 0, 30, false);
    M = new GridSpinner(70, 20, "M", rule.getM(), 0, 30, false);
    N = new GridSpinner(70, 20, "N", rule.getN(), 0, 30, false);
    gridPanel.add(K);
    gridPanel.add(L);
    gridPanel.add(M);
    gridPanel.add(N);
    parametersPanel.add(gridPanel);
    basePanel.add(parametersPanel, BorderLayout.NORTH);
    JPanel buttonPanel = new JPanel();
    buttonPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
    okButton = new JButton("Ok");
    okButton.addActionListener(this);
    buttonPanel.add(okButton);
    cancelButton = new JButton("Cancel");
    cancelButton.addActionListener(this);
    buttonPanel.add(cancelButton);
    basePanel.add(buttonPanel, BorderLayout.SOUTH);
    add(basePanel);
    pack();
    setResizable(false);
    basePanel.requestFocus();
  }

  public void getData(Primordia rule)
  {
    rule.setK(K.getValue());
    rule.setL(L.getValue());
    rule.setM(M.getValue());
    rule.setN(N.getValue());
  }

  public boolean hasChanged()
  {
    return changed;
  }

  public void actionPerformed(ActionEvent e)
  {
    Object source = e.getSource();
    if (source == okButton)
    {
      setVisible(false);
      changed = true;
    }
    else if (source == cancelButton)
    {
      setVisible(false);
      changed = false;
    }
  }
}
 