import java.awt.*;
import javax.swing.*;

public class StatusBar extends JPanel
{
  String cycle;
  String population;
  String worldSize;
  String displaySize;
  String displayOffset;
  String speedDelay;
  String cursorLocation;
  String currentState;
  String patternName;
  JLabel statusBarText;
  
  public StatusBar(int rows, int columns, int displayRows, int displayColumns)
  {
    statusBarText = new JLabel();
    setCycle(0);
    setPopulation(0);
    setWorldSize(rows, columns);
    setDisplaySize(displayRows, displayColumns);
    displayOffset = "";
    speedDelay = "";
    cursorLocation = "";
    currentState = "";
    patternName = "";
    setLayout(new FlowLayout(FlowLayout.LEFT));
    add(statusBarText);
  }

  private void setText()
  {
    statusBarText.setText(cycle + population + worldSize + displaySize + displayOffset +
                          speedDelay + cursorLocation + currentState + patternName);
  }

  public void setCycle(int cycle)
  {
    this.cycle = "Cycle " + cycle;
    setText();
  }

  public void setPopulation(int population)
  {
    this.population = "  Population " + population;
    setText();
  }

  public void removePopulation()
  {
    population = "";
    setText();
  }

  public void setWorldSize(int rows, int columns)
  {
    worldSize = "  World " + columns + "x" + rows;
    setText();
  }

  public void setDisplaySize(int rows, int columns)
  {
    displaySize = "  Display " + columns + "x" + rows;
    setText();
  }

  public void setDisplayOffset(int rows, int columns)
  {
    displayOffset = "  Offset " + columns + "x" + rows;
    setText();
  }

  public void setSpeedDelay(int delay)
  {
    speedDelay = "  Delay " + delay;
    setText();
  }

  public void removeSpeedDelay()
  {
    speedDelay = "";
    setText();
  }

  public void setCursorLocation(int rows, int columns)
  {
    cursorLocation = "  Location " + columns + "x" + rows;
    setText();
  }

  public void removeCursorLocation()
  {
    cursorLocation = "";
    setText();
  }

  public void setCurrentState(int state)
  {
    currentState = "  State " + state;
  }

  public void removeCurrentState()
  {
    currentState = "";
    setText();
  }

  public void setPatternName(String fileName)
  {
    patternName = "  Pattern " + fileName;
    setText();
  }

  public void removePatternName()
  {
    patternName = "";
    setText();
  }
}
